`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    11:34:11 12/26/2021 
// Design Name: 
// Module Name:    Expo 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Expo(
input [13:0] x0,
input clk,reset,start,
output [13:0] xf,yf);
	 
wire [13:0] t2,t3,x1,x2,x3,x4,y1,y2,ln1,ln2;
wire [10:0] t1;
wire [10:0] ln;
wire [3:0] it,it1,it2;
assign reset1 = reset | tc2;
DFF df(start1,clk,reset,start|tc2);
DFF df1(start2,clk,reset,start1);
pg pg1(start|tc2,tc,en,clk,reset);
count4 cnt1(it,4'b0000,tc,en,clk,reset,tc,4'b1001);
DFF df2(tc1,clk,reset,tc);
DFF df3(tc2,clk,reset,tc1);
assign it0 = ~it2[0] & ~it2[1] & ~it2[2] & ~it2[3];
reg4 rg5(it1,clk,reset,it);
reg4 rg6(it2,clk,reset,it1);
Rom2 rm(clk,it,ln,en);
assign ln1 = {3'b000,ln};
reg12 rg1(ln2,clk,reset,ln1);
reg12 rg2(x1,clk,reset,x0);
mux12 mux1(xf,x1,start2,x2);

assign s = x3[13];
adsub ad(1'b0,x2,ln2,x3);
mux12 mux2(x2,x3,s,x4);///need to changed
reg12 rg3(xf,clk,reset1,x4);

siso ss(clk,start|tc2,start1|tc2,t1);
assign t2 = {2'b00,1'b0, 1'b0, t1[9:0]};
mux12 mux3(14'b0001_0000000000,t2,s,t3);//Need to changed
mux12 mux4(yf,14'b0001_0000000000,start2,y1);
mult mu(t3, y1, y2);
reg12 rg4(yf,clk,reset1,y2);
endmodule


module Rom2(clk,addres,data_out,en);
input clk,en;
input [3:0] addres;
output reg [10:0] data_out;
reg [10:0] mem [0:15];
initial begin data_out = 11'b0000000000; end
always @ (addres)
case (addres)
4'b0000 : mem[addres] = 11'b111111_11111;
4'b0001 : mem[addres] = 11'b010110_00110;
4'b0010 : mem[addres] = 11'b001001_00111;
4'b0011 : mem[addres] = 11'b000100_01001;
4'b0100 : mem[addres] = 11'b000010_00010;
4'b0101 : mem[addres] = 11'b000001_00001;
4'b0110 : mem[addres] = 11'b000000_10000;
4'b0111 : mem[addres] = 11'b000000_01000;
4'b1000 : mem[addres] = 11'b000000_00100;
4'b1001 : mem[addres] = 11'b000000_00010;
4'b1010 : mem[addres] = 11'b000000_00001;
default : mem[addres] = 11'b000000_00000;
endcase
always@(posedge clk)
if(en)
data_out <= mem[addres];
else
data_out <= data_out;
endmodule


module reg12(y,clk,reset,a);
    input [13:0] a;
    output [13:0] y;
    input clk,reset;
 
DFF d1(y[0],clk,reset,a[0]);
DFF d2(y[1],clk,reset,a[1]);
DFF d3(y[2],clk,reset,a[2]);
DFF d4(y[3],clk,reset,a[3]);
DFF d5(y[4],clk,reset,a[4]);
DFF d6(y[5],clk,reset,a[5]);
DFF d7(y[6],clk,reset,a[6]);
DFF d8(y[7],clk,reset,a[7]);
DFF d9(y[8],clk,reset,a[8]);
DFF d10(y[9],clk,reset,a[9]);
DFF d11(y[10],clk,reset,a[10]);
DFF d12(y[11],clk,reset,a[11]);
DFF d13(y[12],clk,reset,a[12]);
DFF d14(y[13],clk,reset,a[13]);
endmodule

module reg4(y,clk,reset,a);
    input [3:0] a;
    output [3:0] y;
    input clk,reset;
 
DFF d1(y[0],clk,reset,a[0]);
DFF d2(y[1],clk,reset,a[1]);
DFF d3(y[2],clk,reset,a[2]);
DFF d4(y[3],clk,reset,a[3]);
endmodule

module DFF(q,clk,reset,d);
    input d,clk,reset;
    output reg q;
//initial begin q=0; end
always @ (posedge (clk)) begin
 if (reset)
  q <= 0;
 else  
 q<= d ;
end
endmodule

module adsub (sel,c,a,p);
  input sel;
  input [13:0] a,c;
  output [13:0] p;
 assign p = (sel)?(c-a):(c+a);
endmodule

module mult (a, b, p);
  input signed [13:0] a,b;
  output [13:0] p;
  wire [27:0] p1;
  assign p1 = a*b;
  assign p = p1[23:10];
endmodule

module count4(out,data,load,en,clk,reset,tc,lmt);
output [3:0] out;
output reg tc;
input [3:0] data,lmt;
input load, en, clk,reset;
reg [3:0] out;
//parameter reset=0;

initial begin out=4'b0000; tc =0;end
always @(posedge clk)
if (reset) begin
  out <= 4'b0000 ;
end else if (load) begin
  out <= data;
end else if (en)
  out <= out + 4'b0001;
else out <= out;
always @(posedge clk)
if (out ==lmt)
tc=1;
else tc=0;
endmodule

module pg(start,tc,q,clk,reset);
	 input start,tc,clk,reset;
	 output  q;
	 
	 wire t1,t2;
	 parameter vdd=1'b1;
	 parameter gnd=1'b0;
    Mux M1(t2,vdd,start,q);
	 Mux M2(q,gnd,tc,t1);
	 DFF d2(t2,clk,reset,t1);
//    assign  s1 = (start|tc);
endmodule


module Mux(a,b,s,y);
    input  a,b,s;
    output y;
wire sbar;
assign y = (a&sbar)|(s&b);
assign sbar = ~s;
endmodule

module mux12(A,B,S,Y);

    input [13:0] A,B;
    output [13:0] Y;
    input S;

assign Y = (S)? B : A;
endmodule

module siso(clk,reset,start,q);
input clk,reset,start;
output [10:0] q;
Mux mx(1'b1,1'b1,start,d0);
DFF f1(q[10],clk,reset,d0);
DFF f2(q[9],clk,reset,q[10]);
DFF f3(q[8],clk,reset,q[9]);
DFF f4(q[7],clk,reset,q[8]);
DFF f5(q[6],clk,reset,q[7]);
DFF f6(q[5],clk,reset,q[6]);
DFF f7(q[4],clk,reset,q[5]);
DFF f8(q[3],clk,reset,q[4]);
DFF f9(q[2],clk,reset,q[3]);
DFF f10(q[1],clk,reset,q[2]);
DFF f11(q[0],clk,reset,q[1]);
endmodule